package com.jforeach.mazegame;

import com.jforeach.mazegame.R;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Point;
import android.view.Display;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;

public class GameView extends View {
	
	//width and height of the whole maze and width of lines which
	//make the walls
	private int width, height, lineWidth;
	//size of the maze i.e. number of cells in it
	private int mazeSizeX, mazeSizeY;
	//width and height of cells in the maze
	float cellWidth, cellHeight;
	//the following store result of cellWidth+lineWidth 
	//and cellHeight+lineWidth respectively 
	float totalCellWidth, totalCellHeight;
	//the finishing point of the maze
	private int mazeFinishX, mazeFinishY;
	private Maze maze;
	private Activity context;
	private Paint line, red, background;
	
	int currentX = 20, currentY = 150;
	int ballVelX = 5, ballVelY = 5;
	int i = 1;
	int screenWidth = 450;
	int lineStartX = 100, lineEndX = 470;

	public GameView(Context context, Maze maze) {
		super(context);
		this.context = (Activity)context;
		this.maze = maze;
		mazeFinishX = maze.getFinalX();
		mazeFinishY = maze.getFinalY();
		mazeSizeX = maze.getMazeWidth();
		mazeSizeY = maze.getMazeHeight();
		line = new Paint();
		line.setColor(getResources().getColor(R.color.line));
		red = new Paint();
		red.setColor(getResources().getColor(R.color.position));
		background = new Paint();
		background.setColor(getResources().getColor(R.color.game_bg));
		setFocusable(true);
		this.setFocusableInTouchMode(true);
		
		/*
		 * 
		 * Blah
		 * 
		 * Display display = getWindowToken().getDefaultDisplay();
		Point size = new Point();
		display.getSize(size);
		int screenWidth = size.x;
		int screenheight = size.y;*/
		//currentX = currentX+1;
	}
	protected void onSizeChanged(int w, int h, int oldw, int oldh) {
		width = (w < h)?w:h;
		height = width;         //for now square mazes
		lineWidth = 5;          //for now 1 pixel wide walls
		cellWidth = (width - ((float)mazeSizeX*lineWidth)) / mazeSizeX;
		totalCellWidth = cellWidth+lineWidth;
		cellHeight = (height - ((float)mazeSizeY*lineWidth)) / mazeSizeY;
		totalCellHeight = cellHeight+lineWidth;
		//red.setTextSize(cellHeight*0.75f);
		super.onSizeChanged(w, h, oldw, oldh);
	}
	
	protected void onDraw(Canvas canvas) {
		//fill in the background
		canvas.drawRect(0, 0, width, height, background);
		
		//boolean[][] hLines = maze.getHorizontalLines();
		//boolean[][] vLines = maze.getVerticalLines();
		//iterate over the boolean arrays to draw walls
		/*for(int i = 0; i < mazeSizeX; i++) {
			for(int j = 0; j < mazeSizeY; j++){
				float x = j * totalCellWidth;
				float y = i * totalCellHeight;
				if(j < mazeSizeX - 1 && vLines[i][j]) {
					
				}
				if(i < mazeSizeY - 1 && hLines[i][j]) {
					//we'll draw a horizontal line
					canvas.drawLine(x,               //startX 
									y + cellHeight,  //startY 
								    x + cellWidth,   //stopX 
								    y + cellHeight,  //stopY 
									line);
								
				}
			}
		}*/
		//upper paddle
	
		canvas.drawLine(100, 20, 200, 20, line);
		
		//bottom paddle
		
		canvas.drawLine(lineStartX, 450, lineEndX, 450, line);
		
		
		
		//int currentX = maze.getCurrentX(),currentY = maze.getCurrentY();
		//draw the ball
		//canvas.drawCircle(200, 150, 10, red);
		canvas.drawCircle(currentX,   //x of center
				  currentY,  //y of center
				  5,                           //radius
				  red);
	
		
		
		//images
		
			canvas.drawBitmap(BitmapFactory.decodeResource(getResources(), R.drawable.star), 60, 250, null);
		

			invalidate();
			
			
			//ball movement control
			
			currentX = currentX + ballVelX;
			currentY = currentY + ballVelY;
			
			if(currentX <= 0){
				ballVelX = ballVelX *-1;
			}
			if(currentY <= 0){
				ballVelY = ballVelY *-1;
			}
			
			if(currentX >= 480){
				ballVelX = ballVelX *-1;
			}
			
			if(currentY >= 480 | (currentY == 450 & (currentX > lineStartX & currentX < lineEndX))){
				ballVelY = ballVelY *-1;
			}
			
			
			/*if(i==1){
			currentX = currentX+2;
			currentY = currentY+1;
			i=1;
			}
			
			if(currentX > 0& currentX >= screenWidth | i==2){
				currentX = currentX*-1;
			
				currentY = currentY+1;
				i=2;
		
			}*/

//if(currentX > screenWidth || currentX < 0)
  //   		ballVelocityX *= -1;
	}
	
	/*@Override
	public boolean onKeyDown(int keyCode, KeyEvent evt) {
		boolean moved = false;
		switch(keyCode) {
			case KeyEvent.KEYCODE_DPAD_UP:
				moved = maze.move(Maze.UP);
				break;
			case KeyEvent.KEYCODE_DPAD_DOWN:
				moved = maze.move(Maze.DOWN);
				break;
			case KeyEvent.KEYCODE_DPAD_RIGHT:
				moved = maze.move(Maze.RIGHT);
				break;
			case KeyEvent.KEYCODE_DPAD_LEFT:
				moved = maze.move(Maze.LEFT);
				break;
			default:
				return super.onKeyDown(keyCode,evt);
		}
		if(moved) {
			//the ball was moved so we'll redraw the view
			invalidate();
			if(maze.isGameComplete()) {
				AlertDialog.Builder builder = new AlertDialog.Builder(context);
				builder.setTitle(context.getText(R.string.finished_title));
				LayoutInflater inflater = context.getLayoutInflater();
				View view = inflater.inflate(R.layout.finish, null);
				builder.setView(view);
				View closeButton =view.findViewById(R.id.closeGame);
				closeButton.setOnClickListener(new OnClickListener() {
					@Override
					public void onClick(View clicked) {
						if(clicked.getId() == R.id.closeGame) {
							context.finish();
						}
					}
				});
				AlertDialog finishDialog = builder.create();
				finishDialog.show();
			}
		}
		return true;
	}*/
}
